//
// Fragment Shader by WyldAnimal
// www.deskbabes.net
// trivially modified by ET 13th sept 2017 for slow flame effect ~ET
// made changes so black is now transparent a=0.0 ( alpha channel )
uniform float u_Elapsed; // same than iGlobalTime
uniform vec2 u_WindowSize; // same than iResolution 
uniform sampler2D texture1; // same than iChannel0 
 
// Visual Spectrum code for rainbow of colors
// Based on code by Spektre posted at http://stackoverflow.com/questions/3407942/rgb-values-of-visible-spectrum
// 

// changed so black is transparent
vec4 spectral_colour(float l) // RGB <0,1> <- lambda l <400,700> [nm]
{
	float r=0.0,g=0.0,b=0.0,a=0.0 ;  // all colors and Alpha start black and transparent.
	// adjust color values based on rgb-values-of-visible-spectrum of lambda l
	// if a color is set, than Alpha channel is full opaque a=1.0
         if ((l>=400.0)&&(l<410.0)) { float t=(l-400.0)/(410.0-400.0); r=    +(0.33*t)-(0.20*t*t); a=1.0; }
    else if ((l>=410.0)&&(l<475.0)) { float t=(l-410.0)/(475.0-410.0); r=0.14         -(0.13*t*t); a=1.0; }
    else if ((l>=545.0)&&(l<595.0)) { float t=(l-545.0)/(595.0-545.0); r=    +(1.98*t)-(     t*t); a=1.0; }
    else if ((l>=595.0)&&(l<650.0)) { float t=(l-595.0)/(650.0-595.0); r=0.98+(0.06*t)-(0.40*t*t); a=1.0; }
    else if ((l>=650.0)&&(l<700.0)) { float t=(l-650.0)/(700.0-650.0); r=0.65-(0.84*t)+(0.20*t*t); a=1.0; }
         if ((l>=415.0)&&(l<475.0)) { float t=(l-415.0)/(475.0-415.0); g=             +(0.80*t*t); a=1.0; }
    else if ((l>=475.0)&&(l<590.0)) { float t=(l-475.0)/(590.0-475.0); g=0.8 +(0.76*t)-(0.80*t*t); a=1.0; }
    else if ((l>=585.0)&&(l<639.0)) { float t=(l-585.0)/(639.0-585.0); g=0.82-(0.80*t)           ; a=1.0; }
         if ((l>=400.0)&&(l<475.0)) { float t=(l-400.0)/(475.0-400.0); b=    +(2.20*t)-(1.50*t*t); a=1.0; }
    else if ((l>=475.0)&&(l<560.0)) { float t=(l-475.0)/(560.0-475.0); b=0.7 -(     t)+(0.30*t*t); a=1.0; }
// return r,g,b,a  a=0.0 transparent if color is black
	return vec4(r,g,b,a); 
}

//changed so black is transparent
vec4 spectral_palette(float x) { return spectral_colour(x*300.0+400.0); }

// moving plasma of color
void main()
{
 
// increase & switch values from original
  vec2 p=(3.2*gl_FragCoord.xy-u_WindowSize.xy)/max(u_WindowSize.x,u_WindowSize.y);
	for(int i=1;i<60;i++)
	{
		p=p+vec2(
			0.55/float(i)*cos(float(i)*p.y+.2*u_Elapsed+0.8*float(i))+1.0,
			0.35/float(i)*sin(float(i)*p.x+u_Elapsed+3.5*float(i))-3.4
		);
	}

// changed so Black is transparent.
		vec4 col=spectral_palette(p.x-57.6);
		// use a of spectral_colour formula col.a for alpha channel
	gl_FragColor=vec4(pow(col,vec3(1.0/2.2)),col.a);
}
